/**
 *  Copyright © 2026, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.transfer;

import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import java.lang.reflect.Type;
import java.time.Instant;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.Arrays;



public class TransferOrganizeConferenceCallDeserializer
    implements JsonDeserializer<TransferOrganizeConferenceCall> {

  @Override
  public TransferOrganizeConferenceCall deserialize(JsonElement element, Type type,
      JsonDeserializationContext context) throws JsonParseException {

    TransferOrganizeConferenceCall transfer = new TransferOrganizeConferenceCall();

    JsonObject root = element.getAsJsonObject();

    transfer.setKonferenzname(
        root.getAsJsonPrimitive(TransferOrganizeConferenceCall.KONFERENZNAME).getAsString()
    );
    transfer
        .setBeschreibung(root.getAsJsonPrimitive(TransferOrganizeConferenceCall.DESCRIPTION).getAsString());

    long time = root.getAsJsonPrimitive(TransferOrganizeConferenceCall.DUE).getAsLong();
    ZoneId zoneId = ZoneId.systemDefault();
    ZonedDateTime instant = Instant.ofEpochMilli(time).atZone(zoneId);
    transfer.setZonedAblaufdatum(instant);

    JsonArray teilnehmer = root.getAsJsonArray(TransferOrganizeConferenceCall.PARTICIPANT);
    int count = teilnehmer.size();
    String nicknames[] = new String[count];
    for (int index = 0; index < count; index++) {

      nicknames[index] = teilnehmer.get(index).getAsString();
    }

    transfer.setTeilnehmer(Arrays.asList(nicknames));
    return transfer;
  }

}
